<?php
//t73-110
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class SmartSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct(){
        parent::__construct(self::ID);
    }
	
	public static function get_media_url_str(){
        return MediaURL::encode(array('screen_id' => self::ID));
    }
	
    public function do_get_control_defs(&$plugin_cookies){
        $defs = array();
		$video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;
        $use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;

		$this->add_button(
            $defs,'l_settings',
            '%tr%t73',
            '%tr%t74', 0
		);

        $show_ops[1] = '%tr%t24';
        $show_ops[0] = '%tr%t25';

        $vquality[1] = '360';
        $vquality[2] = '480';
        $vquality[3] = '720';
		if (HD::get_dash_platform_kind()==true)
			$vquality[4] = '1080 Adaptive MPEG-DASH';
		
		ControlFactory::add_smart_label($defs, 
			'%tr%t75', 
			'<text color="10" size="normal">'.SmartConfig::get_data_path().'</text>'
		);
		
		$this->add_button(
            $defs,'data_dialog',
            '',
            '%tr%t76', 0
		);

		ControlFactory::add_smart_label($defs, 
			'%tr%t77', 
			'<text color="10" size="normal">'.smbtree::get_folder_info ('dload_dir_path').'</text>'
		);
			
		$this->add_button($defs,
			'dload_path',
			'',
			'%tr%t78', 0
		);
		
		$this->add_combobox($defs,
			'use_osk', 
			'%tr%t79',
			$use_osk, $show_ops, 0, true
		);
		$this->add_combobox($defs,
			'video_quality',
			'%tr%t80',
			$video_quality, $vquality, 0, true
        );
		
		$this->add_button(
            $defs,'additional_settings',
            '%tr%t81',
            '%tr%t74', 0
		);
		
		$this->add_button(
            $defs,'pin_dialog',
            '%tr%t37',
            '%tr%t74', 0
		);
		$this->add_label($defs, '                                                      ', '');
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies){
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies){
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
		if ($user_input->control_id === 'show_tv')
			$plugin_cookies->show_tv = $user_input->show_tv;
		if ($user_input->control_id === 'show_coment'){
			$plugin_cookies->show_coment = $user_input->show_coment;
			$params['initial_sel_ndx'] = 0;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'skip_details'){
			$plugin_cookies->skip_details = $user_input->skip_details;
			$params['initial_sel_ndx'] = 2;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'create_playlist'){
			HD::save_item('create_playlist'. str_replace(":", "",HD::get_mac_addr()), $user_input->create_playlist);
			$params['initial_sel_ndx'] = 3;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'hls_seek_live'){
			$plugin_cookies->hls_seek_live = $user_input->hls_seek_live;
			$params['initial_sel_ndx'] = 4;
			if ($user_input->hls_seek_live == 1)
				$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			else
				$do_actions = UserInputHandlerRegistry::create_action($this, 'hls_seek_live_warn',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'channel_additional'){
			$plugin_cookies->channel_additional = $user_input->channel_additional;
			$params['initial_sel_ndx'] = 5;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'watched'){
			HD::save_item('watched' . HD::get_mac_addr(1), $user_input->watched);
			if ($user_input->watched == 0)
				HD::save_item('watched_cat'. HD::get_mac_addr(1), 0);
			$params['initial_sel_ndx'] = 7;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'watched_cat'){
			HD::save_item('watched_cat'. HD::get_mac_addr(1), $user_input->watched_cat);
			$params['initial_sel_ndx'] = 8;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'top_menu'){
			HD::save_item('top_menu', $user_input->top_menu);
			$params['initial_sel_ndx'] = 6;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'show_vxp'){
			HD::save_item('show_vxp', $user_input->show_vxp);
			$params['initial_sel_ndx'] = 6;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'hls_seek_live_warn'){
			$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return  ActionFactory::show_title_dialog('%tr%t21', $do_actions, '%tr%t83',1100,1);
		}
		if ($user_input->control_id === 'video_quality')
			$plugin_cookies->video_quality = $user_input->video_quality;
		
		if ($user_input->control_id === 'use_osk')
			HD::save_item('use_osk', $user_input->use_osk);
		
		if ($user_input->control_id === 'backgr_view'){
			$plugin_cookies->backgr_view = $user_input->backgr_view;
			$params['initial_sel_ndx'] = 1;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'additional_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}

		if ($user_input->control_id === 'data_path'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'data_dir_path'
                    )
                );
			$do_actions = ActionFactory::open_folder($media_url,'%tr%t75');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		
		if ($user_input->control_id === 'dload_path'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'dload_dir_path'
                    )
                );
			return ActionFactory::open_folder($media_url,'%tr%t77');
		}
		
		if ($user_input->control_id === 'pin_dialog'){
			$defs = array();
			$this->add_text_field($defs,
				'pin1', '%tr%t84',
				'', 1, 1, 0, 1, 500, 0, false
			);
			$this->add_text_field($defs,
				'pin2', '%tr%t85',
				'', 1, 1, 0, 1, 500, 0, false
			);
			$this->add_label($defs, '%tr%t86', '');
			$this->add_label($defs, '%tr%t87', '');
			$this->add_close_dialog_and_apply_button($defs,'pin_apply', '%tr%t88', 250);					
			return  ActionFactory::show_dialog('%tr%t89',	$defs, true,0,$attrs);
		}
		
		if ($user_input->control_id === 'additional_settings'){
			$defs = array();
			$show_coment = isset($plugin_cookies->show_coment) ? $plugin_cookies->show_coment : 0;
			$backgr_view = isset($plugin_cookies->backgr_view) ? $plugin_cookies->backgr_view : 1;
			$skip_details = isset($plugin_cookies->skip_details) ? $plugin_cookies->skip_details : 1;
			$create_playlist = (HD::get_item('create_playlist'. 
			str_replace(":", "",HD::get_mac_addr())) !='') ? HD::get_item('create_playlist'. 
			str_replace(":", "",HD::get_mac_addr())) : 1;
			$hls_seek_live = isset($plugin_cookies->hls_seek_live) ? $plugin_cookies->hls_seek_live : 1;
			$channel_additional = isset($plugin_cookies->channel_additional) ? $plugin_cookies->channel_additional : 1;
			$show_ops[1] = '%tr%t24';
			$show_ops[0] = '%tr%t25';
			
			$this->add_combobox($defs,
				'show_coment', 
				'%tr%t72',
				$show_coment, $show_ops, 800, true
			);
				
			$this->add_combobox($defs,
				'backgr_view',
				'%tr%t91',
				$backgr_view, $show_ops, 800, true
			);
			
			$this->add_combobox($defs,
				'skip_details', 
				'%tr%t92',
				$skip_details, $show_ops, 800, true
			);
			
			$this->add_combobox($defs,
				'create_playlist', 
				'%tr%t218',
				$create_playlist, $show_ops, 800, true
			);
			$hls_ops[1] = '%tr%t219';
			$hls_ops[0] = '%tr%t220';
			if (file_exists('/codecpack/WWW/cgi-bin/hls.sh'))
				$hls_ops[2] = '%tr%t221';
			$this->add_combobox($defs,
				'hls_seek_live', 
				'%tr%t93',
				$hls_seek_live, $hls_ops, 800, true
			);
			$this->add_combobox($defs,
				'channel_additional', 
				'%tr%t94',
				$channel_additional, $show_ops, 800, true
			);
			if ((HD::get_versions()=== true)&&(Youtube::get_dash_platform_kind()== false)){
				$top_menu = (HD::get_item('top_menu') !='') ? HD::get_item('top_menu') : 1;
				$this->add_combobox($defs,
					'top_menu', 
					'%tr%t95',
					$top_menu, $show_ops, 800, true
				);
			}
			if (Youtube::get_dash_platform_kind()== true){
				$show_vxp = (HD::get_item('show_vxp') !='') ? HD::get_item('show_vxp') : 1;
				$this->add_combobox($defs,
					'show_vxp', 
					'%tr%t96',
					$show_vxp, $show_ops, 800, true
				);
			}
			$watched = (HD::get_item('watched'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched'. HD::get_mac_addr(1)) : 1;
			$this->add_combobox($defs,
				'watched', 
				'%tr%t216',
				$watched, $show_ops, 800, true
			);
			
			$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
			$this->add_combobox($defs,
				'watched_cat', 
				'%tr%t217',
				$watched_cat, $show_ops, 800, true
			);
			
			$this->add_button(
				$defs,'hide_list',
				'%tr%t97',
				'%tr%t98', 800
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return  ActionFactory::show_dialog('%tr%t81',	$defs, true,0, $attrs);
		}
		if ($user_input->control_id === 'hide_pin_control'){
			if ($user_input->hide_pin_control == $pin){
				$params['unlock'] = true;
				$do_actions = UserInputHandlerRegistry::create_action($this, 'hide_list', $params);
				return ActionFactory::close_dialog_and_run($do_actions);
			}
			else
				return  ActionFactory::show_title_dialog_gl('%tr%t28');
		}
		if ($user_input->control_id == 'hide_list'){
			if (!isset($user_input->selected_media_url))
				return null;
			if (($pin != '1111')&&(!isset($user_input->unlock))){
					$defs = array();
					ControlFactory::add_text_field($defs, $this, $add_params=null,
						'hide_pin_control', '',
						'', 1, 1, 0, 1, 500, 0, true);
					return  ActionFactory::show_dialog('%tr%t29',$defs,true,0,$attrs);
				
			}
			$hide_id_defs = HD::get_items('baned_ah');
			if (count($hide_id_defs) == 0)
				return ActionFactory::show_title_dialog_gl('%tr%t30');
			$i=1;
			$cleer_hide_all = UserInputHandlerRegistry::create_action($this, 'cleer_hide_all');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_del', '%tr%t31', 350,  $cleer_hide_all);
			ControlFactory::add_vgap($defs, -25);
			ControlFactory::add_label($defs,'                                           ',' ');
			ControlFactory::add_vgap($defs, -25);
			$i = 1;
			foreach($hide_id_defs as $key => $value){
				$add_params ['ch_pl'] = $key;
				$add_params ['key'] = $i;
				ControlFactory::add_button_close ($defs, $this, $add_params,'cleer_hide', "$i. $value", '%tr%t32', 0);
				$i++;
			}
			$attrs['max_height'] = 740;
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('%tr%t33', $defs, true,0,$attrs);
		}
		if ($user_input->control_id == 'cleer_hide_all'){
			HD::save_items('baned_ah', array());
			return UserInputHandlerRegistry::create_action($this, 'additional_settings');
		}
		if ($user_input->control_id == 'cleer_hide'){
			$hide_id_defs = HD::get_items('baned_ah');
			unset ($hide_id_defs[$user_input->ch_pl]);
			HD::save_items('baned_ah', $hide_id_defs);
			$params['unlock'] = true;
			if ($user_input->key != 1)
				$user_input->key = $user_input->key - 1;
			$params['initial_sel_ndx'] = ($user_input->key);
			return UserInputHandlerRegistry::create_action($this, 'hide_list',$params);
		}
		if ($user_input->control_id === 'data_dialog'){
			$defs = array();
			$this->add_button($defs,
				'data_path',
				'',
				'%tr%t78', 850
			);
			ControlFactory::add_multiline_label($defs, '%tr%t21', '%tr%t99',6);
			ControlFactory::add_img_label($defs, '', '<icon>gui_skin://special_icons/controls_button_blue.aai</icon><text dy="7" size="small"> - select folder</text>', 0, 0, 0);
			$this->add_button(
				$defs,
				'export_data',
				'%tr%t82',
				'%tr%t100',
				850
			);
			$this->add_button(
				$defs,
				'import_data',
				'%tr%t101',
				'%tr%t102',
				850
			);
			$this->add_button(
				$defs,
				'import_file_data',
				'%tr%t103',
				'%tr%t102',
				850
			);
			$this->add_button(
				$defs,
				'clear_data',
				'',
				'%tr%t104',
				850
			);
			return  ActionFactory::show_dialog('%tr%t75',$defs, true,1200,$attrs);
		}
		
		if ($user_input->control_id === 'import_file_data'){
			$media_url = MediaURL::encode (
			array
				(
					'screen_id'     => 'file_list',
					'save_file'		=> array(	
					'parent' 		=> 'tv_group_list',
					'action' 		=> 'import_file_data',
					'extension' 	=> 'all_extension'),
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'%tr%t105');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		
		if ($user_input->control_id === 'clear_data'){
			if (file_exists(DuneSystem::$properties['data_dir_path']))
				shell_exec("rm -rf ".DuneSystem::$properties['data_dir_path']);
			if (!file_exists(DuneSystem::$properties['data_dir_path']))
				mkdir(DuneSystem::$properties['data_dir_path'],0777,true);
			$do_actions = ActionFactory::show_title_dialog_gl('%tr%t106');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		
		if ($user_input->control_id === 'import_data'){
			$media_url = MediaURL::encode
			(
				array
				(
					'screen_id'     => 'file_list',
					'save_data'		=> 'import_data'
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'%tr%t101');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		
		if ($user_input->control_id === 'export_data'){
			$media_url = MediaURL::encode
			(
				array
				(
					'screen_id'     => 'file_list',
					'save_data'		=> 'export_data'
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'%tr%t82');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		
		if ($user_input->control_id === 'pin_apply'){
			if ($user_input->pin1 == '' || $user_input->pin2 == '')
				$msg = '%tr%t107';
			else if ($user_input->pin1 == $pin){
				$plugin_cookies->pin = $user_input->{'pin2'};
				$msg = '%tr%t108';
			}else
				$msg = '%tr%t107';
			return  ActionFactory::show_title_dialog_gl($msg);
		}
		if ($user_input->control_id === 'l_settings'){
			$defs = array();
			$ylb_api_key = Youtube::get_ylb_api_key();
			$country = (HD::get_item('country') !='') ? HD::get_item('country') : 0;
			$local = (HD::get_item('local') !='') ? HD::get_item('local') : 0;
			$jsd = json_decode(HD::http_get_document(API_URL . "/i18nLanguages?part=snippet&key=" . API_KEY));
			foreach ($jsd->items as $v)
				$local_ops[$v->snippet->hl] = $v->snippet->name;
			array_unshift($local_ops, "%ext%<key_local>j__1<p>" . $ylb_api_key['hl'] . "</p></key_local>");
			$jsd = json_decode(HD::http_get_document(API_URL . "/i18nRegions?part=snippet&key=" . API_KEY));
			foreach ($jsd->items as $v)
				$country_ops[$v->snippet->gl] = $v->snippet->name;
			array_unshift($country_ops, "%ext%<key_local>j__1<p>" . $ylb_api_key['cr'] . "</p></key_local>");
			
			$this->add_combobox($defs,
				'local', 
				'%tr%t109',
				$local, $local_ops, 800, true
			);
			
			$this->add_combobox($defs,
				'country',
				'%tr%t110',
				$country, $country_ops, 800, true
			);

			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return  ActionFactory::show_dialog('%tr%t73',	$defs, true,0, $attrs);
		}
		
		if ($user_input->control_id === 'local'){
			HD::save_item('local', $user_input->local);
			SmartConfig::get_ylb_api_key(false, $user_input->local);
			$params['initial_sel_ndx'] = 0;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'l_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}	
		
		if ($user_input->control_id === 'country'){
			HD::save_item('country', $user_input->country);
			SmartConfig::get_ylb_api_key($user_input->country, false);
			$params['initial_sel_ndx'] = 1;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'l_settings',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
