<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod_list_screen.php';

class SmartVodListScreen extends VodListScreen
{
    static public $total;
	public static function get_media_url_str($cat_id, $genre_id=false, $name=false, $poster_url=false, $info=false, $channelId=false, $channelTitle=false)
    {
        $arr['screen_id'] = self::ID;
        $arr['category_id'] = $cat_id;
		if ($genre_id == true)
			$arr['genre_id'] = $genre_id;
		if ($name == true)
			$arr['name'] = $name;
		if ($poster_url == true)
			$arr['poster_url'] = $poster_url;
		if ($info == true)
			$arr['info'] = $info;
		if ($channelId == true)
			$arr['channelId'] = $channelId;
		if ($channelTitle == true)
			$arr['channelTitle'] = $channelTitle;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    public function __construct(Vod $vod)
    {
        parent::__construct($vod);
    }

    ///////////////////////////////////////////////////////////////////////

    protected function get_short_movie_range(MediaURL $media_url, $from_ndx,
        &$plugin_cookies)
    {
		if($media_url->category_id == 'search') {
            $movies = SmartConfig::getSearchList($media_url->genre_id, $media_url->name, $this->vod->m_feed);
            if(!count($movies))
                return new ShortMovieRange(0, 0);
        }else if(preg_match('|videos|',$media_url->category_id)) {
            $movies = SmartConfig::getVideoList($media_url->category_id, $media_url->genre_id, $this->vod->m_feed2);
            if(!count($movies))
                return new ShortMovieRange(0, 0);
        }else{
            $movies = SmartConfig::getVideoList($media_url->category_id, $media_url->genre_id, $this->vod->m_feed);
            if(!count($movies))
                return new ShortMovieRange(0, 0);
        }
        self::$total += count($movies);
        return new ShortMovieRange($from_ndx, self::$total, $movies);
    }

    public function get_folder_range(MediaURL $media_url, $from_ndx, &$plugin_cookies)
    {
		$movie_range = $this->get_short_movie_range($media_url, $from_ndx, $plugin_cookies);
        $total = intval($movie_range->total);
        if ($total <= 0)
            return HD::create_regular_folder_range(array());
		if ($movie_range->from_ndx > 0 && $total == 0){
            return  HD::create_regular_folder_range
                (
                    $items,
                    $movie_range->from_ndx > 0 ? $movie_range->from_ndx - 1 : 0,
                    $movie_range->from_ndx ,
                    false
                );
        }
        $items = array();
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if ($watched_cat == 1)
			$viewed_items = HD::get_items('viewed_items');
        foreach ($movie_range->short_movies as $movie){
			$viewed = ''; $color = 15;
			if (HD::get_versions()=== true)
				$info = $movie->info;
			else
				$info = $movie->name;
			if (($movie->kind == 'youtube#video')||($movie->kind == 'youtube#playlistItem')||($movie->kind == 'youtube#activity')){
				if (($watched_cat == 1)&&(isset($viewed_items[$movie->id]))){
					if ($viewed_items[$movie->id] =='viewed')
						$tt = '[VIEWED]';
					else
						$tt = round(($viewed_items[$movie->id][0]/$viewed_items[$movie->id][1])* 100) . '% ['.HD::sec_format_duration($viewed_items[$movie->id][0]) . '/' . HD::sec_format_duration($viewed_items[$movie->id][1]) . ']';
					$viewed = "|$tt||";
					$color = 19;
				}
				$mUrl = VodMovieScreen::get_media_url_str($movie->id, $movie->name, $movie->poster_url, $movie->url, $info, $movie->channelId, $movie->channelTitle);
			}else if ($movie->kind == 'youtube#playlist'){
				if (!isset($movie->channelId))
					$mUrl = self::get_media_url_str($movie->id, $movie->kind, $movie->name, $movie->poster_url, $info);
				else
					$mUrl = self::get_media_url_str($movie->id, $movie->kind, $movie->name, $movie->poster_url, $info, $movie->channelId, $movie->channelTitle);
			}else if ($movie->kind == 'youtube#channel')
				$mUrl = VodChannelScreen::get_media_url_str('channel', $movie->id, $movie->name, $movie->poster_url);
			else{
				hd_print($movie->kind);
				continue;
			}
			
			$items[] = array
            (
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $movie->name,
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $movie->poster_url,
					ViewItemParams::item_caption_color => $color,
					ViewItemParams::item_detailed_info => $viewed . $movie->info
                )
            );

            $this->vod->set_cached_short_movie(
                new ShortMovie($movie->id, $movie->name, $movie->poster_url, $movie->info));
        }
        return HD::create_regular_folder_range(
            $items, $movie_range->from_ndx, $total, true);
    }    
    
    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
        $this->clear_video_cache();
        $this->vod->m_feed = 0;
		$this->vod->m_feed2 = 0;
        $this->vod->folder_entered($media_url, $plugin_cookies);
        return parent::get_folder_view($media_url, $plugin_cookies);
    }
    
    private function clear_video_cache() {
        self::$total = 0;
        $this->vod->clear_movie_cache();
    }
    
}

///////////////////////////////////////////////////////////////////////////
?>
