<?php
//t111-
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod_list_screen.php';

class SmartVodSimpleListScreen extends AbstractRegularScreen
    implements UserInputHandler
{
	const ID = 'vod_simplelist';
    static public $total;
	public static function get_media_url_str($cat_id, $genre_id=false, $name=false, $poster_url=false, $info=false)
    {
        $arr['screen_id'] = self::ID;
        $arr['category_id'] = $cat_id;
		if ($genre_id == true)
			$arr['genre_id'] = $genre_id;
		if ($name == true)
			$arr['name'] = $name;
		if ($poster_url == true)
			$arr['poster_url'] = $poster_url;
		if ($info == true)
			$arr['info'] = $info;

        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;

    public function __construct(Vod $vod)
    {
        parent::__construct(self::ID, $this->get_folder_views());

        $this->vod = $vod;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }
	public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
		$actions = array();
		$actions[GUI_EVENT_KEY_SETUP]	= ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'%tr%t4');
		$actions[GUI_EVENT_KEY_ENTER]	= ActionFactory::open_folder();
        $actions[GUI_EVENT_KEY_PLAY] 	= UserInputHandlerRegistry::create_action($this, 'add_actions');
		$add_action = UserInputHandlerRegistry::create_action($this, 'add_favorite');
        $add_action['caption'] = '%tr%t67';
		if (($media_url->genre_id != 'home_categories')&&($media_url->genre_id != 'myhome_categories'))
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'search');
        $add_action['caption'] = '%tr%t54';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		if ($media_url->category_id == 'v3subscriptions'){
			$add_action = UserInputHandlerRegistry::create_action($this, 'sort_category');
			$add_action['caption'] = '%tr%t111';
			$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		}
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if ($watched_cat == 1)
			$actions[GUI_EVENT_KEY_SELECT]	= UserInputHandlerRegistry::create_action($this, 'viewed');
        $actions[GUI_EVENT_KEY_POPUP_MENU] = UserInputHandlerRegistry::create_action($this, 'popup_menu');
        return $actions;
    }

    public function get_handler_id()
    { return self::ID; }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {		
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($user_input->control_id == 'add_actions'){
			SmartConfig::current_url($user_input->parent_media_url);
			return ActionFactory::vod_play();
		}
		if ($user_input->control_id == 'sort_category'){
            $media_url = MediaURL::decode($user_input->parent_media_url);
			$defs = array();
			$sort_page_settings = HD::get_items('sort_page_settings');
			$sorting = isset($sort_page_settings[$media_url->genre_id][$media_url->category_id]['sorting']) ? $sort_page_settings[$media_url->genre_id][$media_url->category_id]['sorting'] : '&order=relevance';

			$sorting_ops['&order=alphabetical']	= '%tr%t112';
			$sorting_ops['&order=relevance']	= '%tr%t113';
			$sorting_ops['&order=unread']		= '%tr%t114';

			ControlFactory::add_combobox($defs, $this, null,
			'sorting', 'Cортировать:',
			$sorting, $sorting_ops, 700, false, false);
			
			$do = UserInputHandlerRegistry::create_action($this, 'save_sort_page');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,	'_do_save_sort_page', '%tr%t88', 300, $do);
			$do = UserInputHandlerRegistry::create_action($this, 'clear_sort_page');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,	'_do_clear_sort_page', '%tr%t115', 300, $do);	
            return ActionFactory::show_dialog('%tr%t116', $defs,	true, 1100,$attrs);
		}
		if ($user_input->control_id == 'save_sort_page'){
            $media_url = MediaURL::decode($user_input->parent_media_url);
			$sort_page_settings = HD::get_items('sort_page_settings');
			if (isset($user_input->sorting))
				$sort_page_settings[$media_url->genre_id][$media_url->category_id]['sorting'] = $user_input->sorting;
			HD::save_items('sort_page_settings', $sort_page_settings);
			$this->vod->clear_movie_cache();
			$this->vod->m_feed = 0;
			return ActionFactory::update_regular_folder($this->get_folder_range($media_url, 0, $plugin_cookies), true, 0);
		}
		if ($user_input->control_id == 'search'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_search', '',
			$media_url->name, 0, 0, $use_osk, 1, 1300,0,1);
			if ($use_osk == 1)
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t54', $defs, true, 0,$attrs);
		}
		
		if ($user_input->control_id == 'do_new_search'){
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_search');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		
		if ($user_input->control_id == 'do_search'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			HD::save_item('search_item', $user_input->do_new_search);
			$search_items = HD::get_items('search_items');
			$k = array_search($user_input->do_new_search, $search_items);
			if ($k !== false)
				unset ($search_items [$k]);
			array_unshift($search_items, $user_input->do_new_search); 
			HD::save_items('search_items', $search_items);
			$action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('search', $user_input->do_new_search), "%ext%<key_local>o__1<p>".$user_input->do_new_search."</p></key_local>");
			return ActionFactory::invalidate_folders(array('search_screen'),$action);
		}
		if ($user_input->control_id == 'subscription'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$jsd = SmartConfig::do_get_ylb_api('subscription/'.  $user_input->subscription_action,false, false, false, false, false, false, false, false, $media_url->first_arg);
			SmartConfig::get_videoId_arr($media_url->movie_id, false, false, $user_input->subscription_action);
			if ( $user_input->subscription_action == 'unsubscribe')
				$capt = "%ext%<key_local>k__1<p>" . $media_url->second_arg . "</p></key_local>";
			else if ( $user_input->subscription_action == 'subscribe')
				$capt = "%ext%<key_local>l__1<p>" . $media_url->second_arg . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'viewed'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->movie_id)){	
				$viewed_items = HD::get_items('viewed_items');
				$is_viewed = (array_key_exists($media_url->movie_id, $viewed_items)) ? 1 : 0;
				if ($is_viewed == 1){
					$msg = '%tr%t212';
					unset ($viewed_items[$media_url->movie_id]);
				}else{
					$msg = '%tr%t213';
					$viewed_items[$media_url->movie_id] = 'viewed';
				}
				HD::save_items('viewed_items', $viewed_items);
				// return ActionFactory::show_title_dialog($msg,null,'%tr%t214',800,1);
				// return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				$action  = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				return ActionFactory::show_title_dialog($msg,$action,'',800,1);
				// $parent_media_url = MediaURL::decode($user_input->parent_media_url);
				// $sel_ndx = $user_input->sel_ndx;
					// if ($sel_ndx < 0)
						// $sel_ndx = 0;
				// $range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
				// return ActionFactory::update_regular_folder($range, true, $sel_ndx);
			}
		}
        if ($user_input->control_id == 'popup_menu'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->parent_media_url);
			if (($media_url->genre_id != 'home_categories')&&($media_url->genre_id != 'myhome_categories')){
				$this->vod->ensure_favorites_loaded($plugin_cookies);
				$is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
				if ($is_favorite)
					$caption = '%tr%t68';
				else
					$caption = '%tr%t69';
				$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_favorite');
				$menu_items[] = array(
					GuiMenuItemDef::caption => $caption,
					GuiMenuItemDef::action => $add_favorite_action,
					GuiMenuItemDef::icon_url => 'gui_skin://small_icons/favorites.aai');
			}
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$tokens = SmartConfig::get_tokens();
			if ((isset($tokens['access_token']))&&(isset($media_url->action))&&($media_url->action=='channel')){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				if (SmartConfig::get_subscribed_inf($media_url->first_arg) == 1){
					$params['subscription_action'] = 'unsubscribe';
					$capt = "%ext%<key_local>m__1<p>" . $media_url->second_arg . "</p></key_local>";
				}else{
					$params['subscription_action'] = 'subscribe';
					$capt = "%ext%<key_local>n__1<p>" . $media_url->second_arg . "</p></key_local>";
				}
				$menu_items[] = array(
				GuiMenuItemDef::caption =>  $capt,
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'subscription', $params),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/'.$params['subscription_action'].'.png');
				
			}
			if (isset($media_url->movie_id)){
				$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
				if ($watched_cat == 1)
					$menu_items[] = array(
						GuiMenuItemDef::caption => '%tr%t215',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'viewed'),
						GuiMenuItemDef::icon_url => 'gui_skin://small_icons/bookmarks_settings.aai'
					);	
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);	
			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t19',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_vod_list_bg'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($plugin_ico['vod_list_bg'])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t50',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_vod_list_bg'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
            return ActionFactory::show_popup_menu($menu_items);
        }
		
		if ($user_input->control_id == 'add_vod_list_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' 		=> self::ID,
						'action' 		=> 'plugin_ico',
						'arg' 			=> 'vod_list_bg',
						'msg' 			=> '%tr%t18',
						'extension' 	=> 'jpg'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t19');
		}
		
		if ($user_input->control_id == 'del_vod_list_bg'){
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$plugin_ico = HD::get_items('plugin_ico');
			unlink($plugin_ico['vod_list_bg']);
			unset ($plugin_ico['vod_list_bg']);
			HD::save_items('plugin_ico', $plugin_ico);
			return ActionFactory::invalidate_folders(array('vod_category_list'), 
			ActionFactory::show_title_dialog('%tr%t20',null,'%tr%t18',800,1));
		}
		
        if ($user_input->control_id == 'add_favorite'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$this->vod->ensure_favorites_loaded($plugin_cookies);
			$is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
			$ufav_itms = HD::get_items('ufav_itms');
			if (!empty($ufav_itms)){
				if ($is_favorite)
					$caption = '%tr%t68';
				else
					$caption = '%tr%t69';
				$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				foreach ($ufav_itms as $k => $v){
					$caption = "%ext%<key_local>i__1<p>$v</p></key_local>";
					$params['ufav_itms_name'] = $k;
					$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav_itm',$params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				}
				return ActionFactory::show_dialog('%tr%t55', $defs, true, 0,$attrs);
			}else{
				if ($is_favorite){
					$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t70');
				}else{
					$this->vod->add_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t71');
				}
			}
			
        }
		if ($user_input->control_id == 'add_fav_itm'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$fav_movies = HD::get_items($user_input->ufav_itms_name);
			$flipped = array_flip($fav_movies);
			if (isset($flipped[$user_input->selected_media_url])){
				unset ($flipped[$user_input->selected_media_url]);
				$fav_movies = array_flip($flipped);
				$fav_movies = array_values($fav_movies);
				HD::save_items($user_input->ufav_itms_name, $fav_movies);
				return ActionFactory::show_title_dialog_gl('%tr%t70');
			}else{
				array_unshift($fav_movies,$user_input->selected_media_url);
				HD::save_items($user_input->ufav_itms_name, $fav_movies);
				return ActionFactory::show_title_dialog_gl('%tr%t71');
			}
        }
		if ($user_input->control_id == 'add_fav'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$this->vod->ensure_favorites_loaded($plugin_cookies);
            $is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
            if ($is_favorite){
				$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
                return ActionFactory::show_title_dialog_gl('%tr%t70');
			}
            else{
                $this->vod->add_favorite_movie($user_input->selected_media_url, $plugin_cookies);
                return ActionFactory::show_title_dialog_gl('%tr%t71');
            }
        }

        return null;
    }
    ///////////////////////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////////////////////

    protected function get_short_movie_range(MediaURL $media_url, $from_ndx,
        &$plugin_cookies)
    {
		if($media_url->category_id == 'search') {
            $movies = SmartConfig::getSearchList($media_url->genre_id, $media_url->name, $this->vod->m_feed);
            if(!count($movies))
                return new ShortMovieRange(0, 0);
        }else{
            $movies = SmartConfig::getVideoList($media_url->category_id, $media_url->genre_id, $this->vod->m_feed);
            if(!count($movies))
                return new ShortMovieRange(0, 0);
        }
        self::$total += count($movies);
        return new ShortMovieRange($from_ndx, self::$total, $movies);
    }

    public function get_folder_range(MediaURL $media_url, $from_ndx, &$plugin_cookies)
    {
		$movie_range = $this->get_short_movie_range(
            $media_url, $from_ndx, $plugin_cookies);
        $total = intval($movie_range->total);
        if ($total <= 0)
            return HD::create_regular_folder_range(array());
		if ($movie_range->from_ndx > 0 && $total == 0){
            return  HD::create_regular_folder_range
                (
                    $items,
                    $movie_range->from_ndx > 0 ? $movie_range->from_ndx - 1 : 0,
                    $movie_range->from_ndx ,
                    false
                );
        }
        $items = array();
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if ($watched_cat == 1)
			$viewed_items = HD::get_items('viewed_items');
        foreach ($movie_range->short_movies as $movie){
			$viewed = ''; $color = 15;
			if (HD::get_versions()=== true)
				$info = $movie->info;
			else
				$info = $movie->name;
			if (($media_url->genre_id == 'home_categories')||($media_url->genre_id == 'myhome_categories')){
				$mUrl = VodTop500Screen::get_media_url_str('videoId_arr', urlencode (json_encode ($movie->arr)), $movie->name);
			}else if (($movie->kind == 'youtube#video')||($movie->kind == 'youtube#playlistItem')||($movie->kind == 'youtube#activity')){
				if (($watched_cat == 1)&&(isset($viewed_items[$movie->id]))){
					if ($viewed_items[$movie->id] =='viewed')
						$tt = '[VIEWED]';
					else
						$tt = round(($viewed_items[$movie->id][0]/$viewed_items[$movie->id][1])* 100) . '% ['.HD::sec_format_duration($viewed_items[$movie->id][0]) . '/' . HD::sec_format_duration($viewed_items[$movie->id][1]) . ']';
					$viewed = "|$tt||";
					$color = 19;
				}
				$mUrl = VodMovieScreen::get_media_url_str($movie->id, $movie->name, $movie->poster_url, $movie->url, $info, $movie->channelId, $movie->channelTitle);
			}else if ($movie->kind == 'youtube#playlist')
				$mUrl = self::get_media_url_str($movie->id, $movie->kind, $movie->name, $movie->poster_url, $info);
			else if (($movie->kind == 'youtube#channel')||($movie->kind == 'youtube#subscription'))
				$mUrl = VodChannelScreen::get_media_url_str('channel', $movie->id, $movie->name, $movie->poster_url);
			else{
				hd_print('!Err->' .  $movie->kind);
				continue;
			}
			$items[] = array
            (
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $movie->name,
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $movie->poster_url,
					ViewItemParams::item_caption_color => $color,
					ViewItemParams::item_detailed_info => $viewed . $movie->info
                )
            );

            $this->vod->set_cached_short_movie(
                new ShortMovie($movie->id, $movie->name, $movie->poster_url, $movie->info));
        }
        return HD::create_regular_folder_range(
            $items, $movie_range->from_ndx, $total, true);
    }    
    
    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
        $this->clear_video_cache();
        $this->vod->m_feed = 0;
        $this->vod->folder_entered($media_url, $plugin_cookies);
        return parent::get_folder_view($media_url, $plugin_cookies);
    }
    
    private function clear_video_cache() {
        self::$total = 0;
        $this->vod->clear_movie_cache();
    }
	
    private function get_folder_views()
    {
        return array(
            array
				(
                        PluginRegularFolderView::async_icon_loading => true,
						PluginRegularFolderView::timer => array(GuiTimerDef::delay_ms => 5000),
                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,               
                            ViewParams::num_rows => 10,
                            ViewParams::paint_details => true,
                            ViewParams::paint_item_info_in_details => true,
							ViewParams::item_detailed_info_auto_line_break => true,
							ViewParams::item_detailed_info_title_color => 10,
							ViewParams::item_detailed_info_text_color => 15,
							ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
							ViewParams::background_order => 0,
							ViewParams::background_height => 1080,
							ViewParams::background_width => 1920,
                            ViewParams::paint_item_info_in_details => true,
                            ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,

                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 50,
                            ViewParams::sandwich_height => 50,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 50,
                            ViewItemParams::icon_height => 50,
                            ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 50,
                            ViewItemParams::icon_height => 50,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 1100
                        ),
				),
			array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
                    ViewParams::paint_item_info_in_details => true,
                    ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 150,
                    ViewParams::sandwich_height => 150,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
		array
				(
                        PluginRegularFolderView::async_icon_loading => true,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 5,
                            ViewParams::paint_details => true,
                            ViewParams::paint_item_info_in_details => true,
							ViewParams::item_detailed_info_auto_line_break => true,
							ViewParams::item_detailed_info_title_color => 10,
							ViewParams::item_detailed_info_text_color => 15,
							ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
							ViewParams::background_order => 0,
							ViewParams::background_height => 1080,
							ViewParams::background_width => 1920,
							ViewParams::optimize_full_screen_background => true,
							ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,
                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 112,
                            ViewParams::sandwich_height => 112,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 112,
                            ViewItemParams::icon_height => 112,
                            ViewItemParams::icon_path => 'plugin_file://icons/mov_unset2.png'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 112,
                            ViewItemParams::icon_height => 112,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 990
                        ),
				),
        );
    }
}

///////////////////////////////////////////////////////////////////////////
?>
