<?php
///////////////////////////////////////////////////////////////////////////
//t158-158
require_once 'lib/screen.php';
require_once 'lib/vod/vod.php';
require_once 'lib/vod/vod_series_list_screen.php';

class VodMovieScreen implements Screen, UserInputHandler
{
    const ID = 'vod_movie';

    public static function get_media_url_str($movie_id, $name=false, $poster_url=false, $url=false, $info=false, $channelId=false, $channelTitle=false, $fav_str=false)
    {
		$arr['screen_id'] = self::ID;
        $arr['movie_id'] = $movie_id;
		if ($name == true)
			$arr['name'] = $name;
		if ($poster_url == true)
			$arr['poster_url'] = $poster_url;
		if ($url == true)
			$arr['url'] = $url;
		if ($info == true)
			$arr['info'] = $info;
		if ($channelId == true)
			$arr['channelId'] = $channelId;
		if ($channelTitle == true)
			$arr['channelTitle'] = $channelTitle;
		if ($fav_str == true)
			$arr['fav_str'] = $fav_str;
        return MediaURL::encode($arr);		
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;

    public function __construct(Vod $vod)
    {
        $this->vod = $vod;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_id()
    { return self::ID; }

    public function get_handler_id()
    { return self::ID; }

    ///////////////////////////////////////////////////////////////////////

    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
		$backgr_view = isset($plugin_cookies->backgr_view) ? $plugin_cookies->backgr_view : 1;
		$this->vod->folder_entered($media_url, $plugin_cookies);
		$this->vod->folder_movie = $media_url->get_raw_string();
        $movie = $this->vod->get_loaded_movie($media_url->movie_id, $media_url->name, $media_url->poster_url, $media_url->url, $plugin_cookies);

		$mUrl = VodSeriesListScreen::get_media_url_str($movie->id, $movie->name, $movie->poster_url, $media_url->url);
		if ($backgr_view == 1)
			$background_url = $movie->images[0];
		else
			$background_url = 'gui_skin://images/bg.jpg';
		$hls_seek_live = isset($plugin_cookies->hls_seek_live) ? $plugin_cookies->hls_seek_live : 1;
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if (($hls_seek_live == 0)&&($watched_cat == 0))
			$left_button_action = null;
		else
			$left_button_action = ActionFactory::vod_play();
        $movie_folder_view = array
        (
            PluginMovieFolderView::movie => $movie->get_movie_array(),
            PluginMovieFolderView::has_right_button => true,
            PluginMovieFolderView::right_button_caption => '%tr%t158',
            PluginMovieFolderView::right_button_action => 
			UserInputHandlerRegistry::create_action($this, 'button_actions'),
			PluginMovieFolderView::left_button_action => $left_button_action,
            PluginMovieFolderView::has_multiple_series => true,
            PluginMovieFolderView::series_media_url => $mUrl,
			PluginMovieFolderView::params => array
            (			               
				PluginFolderViewParams::paint_path_box =>false,
                PluginFolderViewParams::paint_content_box_background => true,
               	PluginFolderViewParams::background_url => $background_url
				
            )
        );

        return array
        (
            PluginFolderView::multiple_views_supported  => false,
            PluginFolderView::archive                   => null,
            PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_MOVIE,
            PluginFolderView::data                      => $movie_folder_view,
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {		
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($user_input->control_id == 'likeStatus'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$jsd = SmartConfig::do_get_ylb_api('like/'.  $user_input->like_action ,false,false,false,false,false,false,false,$media_url->movie_id);
			SmartConfig::get_videoId_arr($media_url->movie_id, false, strtoupper ($user_input->like_action));
			if ( $user_input->like_action == 'like')
				$capt = '%tr%t144';
			else if ( $user_input->like_action == 'dislike')
				$capt = '%tr%t145';
			else
				$capt = "%ext%<key_local>s__1<p>" . $user_input->like_Status . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'subscription'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$jsd = SmartConfig::do_get_ylb_api('subscription/'.  $user_input->subscription_action,false, false, false, false, false, false, false, false, $media_url->channelId);
			SmartConfig::get_videoId_arr($media_url->movie_id, false, false, $user_input->subscription_action);
			if ( $user_input->subscription_action == 'unsubscribe')
				$capt = "%ext%<key_local>t__1<p>" . $media_url->channelTitle . "</p></key_local>";
			else if ( $user_input->subscription_action == 'subscribe')
				$capt = "%ext%<key_local>u__1<p>" . $media_url->channelTitle . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'add_playlist'){
			if ($user_input->playlistId == '0'){
				$jsd = SmartConfig::http_get_api_v3('/playlists?part=snippet%2Cstatus', '{"snippet": {"title": "'.$user_input->newPlaylistName.'","description":"Created on Dune HD! Enjoy!"},"status":{"privacyStatus":"private"}}');
				$user_input->playlistId = $jsd->id;
				$user_input->playlistName = $user_input->newPlaylistName;
			}
			$resp = SmartConfig::http_get_api_v3('/playlistItems?part=snippet', '{"snippet":{"playlistId": "'.$user_input->playlistId.'","resourceId":{"kind": "youtube#video","videoId": "'.$user_input->videoId.'"}}}');
			ControlFactory::add_multiline_label($defs, '', $resp->snippet->title, 5);
			ControlFactory::add_close_dialog_button($defs, 'OK', 400);
			if (!isset($user_input->playlistName)){
				$pl_ops = json_decode($user_input->pl_ops);
				$user_input->playlistName = $pl_ops->{$user_input->playlistId};
			}
			$params['playlistName'] = $user_input->playlistName;
			$params['playlistId'] = $user_input->playlistId;
			$action = UserInputHandlerRegistry::create_action($this, 'open_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t146', 400, $action);
			return ActionFactory::show_dialog("%ext%<key_local>v__1<p>" . $user_input->playlistName . "</p></key_local>", $defs,	true, 1100,$attrs);
		}
		if ($user_input->control_id == 'open_playlist')
			return ActionFactory::open_folder(SmartVodListScreen::get_media_url_str($user_input->playlistId, 'youtube#playlist', $user_input->playlistName),$user_input->playlistName);
		if ($user_input->control_id == 'add_to_playlist'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$pl_ops[0] = '%tr%t147';
			$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true");
			$playlists = $jsd->items;
			if (isset($jsd->nextPageToken)){
				$i=0;
				do {
					$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true&pageToken=". $jsd->nextPageToken);
					$playlists = array_merge_recursive($playlists,$jsd->items);
					if (!isset($jsd->nextPageToken))
						break;
					++$i;
				} while (($i < 25)&&(isset($jsd->nextPageToken)));
			}
			foreach ($playlists as $value)
				$pl_ops[$value->id] = $value->snippet->title;
			ControlFactory::add_combobox($defs, $this, null,
				'playlistId', '',
				0, $pl_ops, 1000, $need_confirm = false, $need_apply = false
			);
			ControlFactory::add_label($defs, "", '%tr%t148');
			ControlFactory::add_text_field($defs,
				$this, null,
				'newPlaylistName', '',
				$media_url->name, 0, 0, 0, 1, 1000);
			$params['videoId'] = $user_input->videoId;
			$params['pl_ops'] = json_encode($pl_ops);
			$action = UserInputHandlerRegistry::create_action($this, 'add_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_new_mypl', '%tr%t149', 500, $action);
			return  ActionFactory::show_dialog('%tr%t150', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'button_actions'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$movie = $this->vod->get_loaded_movie($media_url->movie_id, $media_url->name, $media_url->poster_url, $media_url->info, $plugin_cookies);

			$defs = array();
			$this->vod->ensure_favorites_loaded($plugin_cookies);
            $is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
			if ($is_favorite)
				$caption = '%tr%t68';
			else
				$caption = '%tr%t69';
			$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_favorite');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 1100, $add_favorite_action);
			
			$add_action = UserInputHandlerRegistry::create_action($this, 'search');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t54', 1100, $add_action);
			
			$add_action = UserInputHandlerRegistry::create_action($this, 'reviews');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t124', 1100, $add_action);
			
			$add_action = ActionFactory::open_folder(VodChannelScreen::get_media_url_str('channel', $media_url->channelId,$media_url->channelTitle),$media_url->channelTitle);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', "%ext%<key_local>z2__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>", 1100, $add_action);
			
			$add_action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str(API_URL . "/search?relatedToVideoId=". $media_url->movie_id . "&part=snippet&type=video&maxResults=50&key=". API_KEY, 'relatedToVideoId', $media_url->name),"%ext%<key_local>z4__1<p>" . $media_url->name . "</p></key_local>");
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', '%tr%t154', 1100, $add_action);
			if ((!isset($media_url->channelTitle))&&(isset($media_url->channelId))){
				$jsdo =json_decode (HD::http_get_document(API_URL."/channels?part=snippet&id=".$media_url->channelId."&key=".API_KEY));
				$media_url->channelTitle = $jsdo->items[0]->snippet->title;
			}
			if (isset($media_url->movie_id)){
				$videoId_arr = SmartConfig::get_videoId_arr($media_url->movie_id);
				$nameAkk = SmartConfig::get_tokens(false,false,1);
				if (isset($videoId_arr['likeStatus'])){
					if ($videoId_arr['likeStatus'] == 'INDIFFERENT'){
						$params['like_action'] = 'like';
						$menu_items[] = array(
						GuiMenuItemDef::caption => "%ext%<key_local>w__1<p>" . $nameAkk . "</p></key_local>",
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'likeStatus', $params),
						GuiMenuItemDef::icon_url => "plugin_file://icons/like.png");
							
						$params['like_action'] = 'dislike';
						$menu_items[] = array(
						GuiMenuItemDef::caption => "%ext%<key_local>x__1<p>" . $nameAkk . "</p></key_local>",
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'likeStatus', $params),
						GuiMenuItemDef::icon_url => "plugin_file://icons/dislike.png");
					}else{
						if ($videoId_arr['likeStatus'] == 'LIKE'){
							$capt = '%tr%t144';
							$capt2 = "%ext%<key_local>y__1<p>" . $nameAkk . "</p></key_local>";
						}
						if ($videoId_arr['likeStatus'] == 'DISLIKE'){
							$capt = '%tr%t145';
							$capt2 = "%ext%<key_local>y1__1<p>" . $nameAkk . "</p></key_local>";
						}
						$params['like_Status'] = $capt;
						$params['like_action'] = 'removelike';
						$add_action = UserInputHandlerRegistry::create_action($this, 'likeStatus', $params);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $capt2, 1100, $add_action);
					}
					$params['videoId'] = $media_url->movie_id;
					$add_action = UserInputHandlerRegistry::create_action($this, 'add_to_playlist', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', '%tr%t150', 1100, $add_action);
					$relatedPlaylists = SmartConfig::get_relatedPlaylists();
					foreach ($relatedPlaylists as $k => $v){
						$l = array('favorites' => '%tr%t151', 'watchLater' => '%tr%t152');
						if (isset($l[$k]))
							$caption = $l[$k];
						else
							continue;
						$params['playlistName'] = str_replace('%tr%t153', '', $caption);
						$params['playlistId'] = $v;
						$params['videoId'] = $media_url->movie_id;
						$add_action = UserInputHandlerRegistry::create_action($this, 'add_playlist', $params);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $caption, 1100, $add_action);
					}
					if ($videoId_arr['subscribed'] == 1){
						$params['subscription_action'] = 'unsubscribe';
						$p_capt =  "%ext%<key_local>z__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
					}else{
						$params['subscription_action'] = 'subscribe';
						$p_capt = "%ext%<key_local>z1__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
					}
					$add_action = UserInputHandlerRegistry::create_action($this, 'subscription', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $p_capt, 1100, $add_action);
					unset ($videoId_arr['likeStatus'],$videoId_arr['subscribed']);
				}
				foreach ($videoId_arr as $k => $v){
					if (isset($v['shelfIdentifier'])){
						if ($v['shelfIdentifier'] == 'ALBUMS'){
							unset ($v['shelfIdentifier']);
							$mUrl = VodChannelScreen::get_media_url_str('albums', urlencode(json_encode ($v)), $media_url->channelTitle);
							$k .= ' '. $media_url->channelTitle;
						}else{
							unset ($v['shelfIdentifier']);
							$mUrl = VodTop500Screen::get_media_url_str('videoId_arr', urlencode(json_encode ($v)), $k);
						}
					}
					$add_action = ActionFactory::open_folder($mUrl, $k);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $k, 1100, $add_action);
				}
			}
			if (file_exists('/codecpack/script/youtube_download.sh')){
				$capt = '%tr%t155';
				$add_action = UserInputHandlerRegistry::create_action($this, 'video_dload');
				if (file_exists('/tmp/yt'))
					$capt = '%tr%t156';
				if (file_exists('/tmp/plugins/youtube/streamrecord.sh')){
					$capt = '%tr%t134';
					$add_action = UserInputHandlerRegistry::create_action($this, 'stop_rec_conf');
				}
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $capt, 1100, $add_action);
				$add_action = UserInputHandlerRegistry::create_action($this, 'open_folder');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', '%tr%t157', 1100, $add_action);
			}
			return ActionFactory::show_dialog('%tr%t158', $defs, true, 0,$attrs);
		}
		if ($user_input->control_id == 'open_folder'){
			$media_url = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] .'/dload_dir_path'));
			$path = smbtree::get_folder_info ('dload_dir_path');
			if (preg_match('|^/tmp/mnt/storage/|', $path))
				$path = preg_replace('|^/tmp/mnt/storage/|', 'storage_name://', $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path))&&($media_url['user']==true)&&($media_url['password']==true))
				$path = 'smb://'. $media_url['user'] .':'. $media_url['password'] .'@'. preg_replace("|^\/tmp\/mnt\/smb\/\d|", str_replace('//', '',$media_url['ip_path']), $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path)))
				$path = 'smb:' . preg_replace("|^\/tmp\/mnt\/smb\/\d|", $media_url['ip_path'], $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/network/|', $path))&&($media_url['nfs_protocol']==true)){
				if ($media_url['nfs_protocol']=='tcp')
					$path = 'nfs-tcp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
				else
					$path = 'nfs-udp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
			}
			$url = 'embedded_app://{name=file_browser}{url='.$path.'}{caption=File Browser}';
			return ActionFactory::launch_media_url($url);
		}
		if ($user_input->control_id == 'reviews'){
			$media_url = MediaURL::decode($user_input->selected_media_url); $pages = '';
			if (isset($user_input->nextPageToken)){
				$arr[$media_url->movie_id] = $nextPageToken = $user_input->nextPageToken;
				$this->commentСounter = $arr;
			}else{
				if (isset($this->commentСounter[$media_url->movie_id])){
					ControlFactory::add_multiline_label($defs, '', '%tr%t138', 2);
					$add_params ['nextPageToken'] = $this->commentСounter[$media_url->movie_id];
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t24', 350);
					$add_params ['nextPageToken'] = 0;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t25', 350);
					return  ActionFactory::show_dialog('' ,$defs,true,0,$attrs);
				}else{
					$this->commentСounter = null;
					$nextPageToken = 0;
				}
			}
			if (isset ($media_url->movie_id)){
				$jsd = SmartConfig::parse_film_review($media_url->movie_id, $nextPageToken);
				if ($jsd == true){
					$coments = HD::str_remove_tag($jsd->textOriginal);
					$pages = 'Comments: ' . $media_url->name;
					ControlFactory::add_smart_label($defs,"", '<icon width="160" height="160">'.str_replace(array("https://",'/s28-'),array("http://",'/s160-' ),$jsd->authorProfileImageUrl).'</icon>');
					ControlFactory::add_vgap($defs, -75);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Author: </text><text color="10" size="normal">'.$jsd->authorDisplayName.'</text>');
					$date = new DateTime($jsd->publishedAt);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Date: </text><text color="10" size="normal">'.$date->format('d.m.Y').' </text>');
					ControlFactory::add_vgap($defs, 35);
					ControlFactory::add_smart_label($defs,"", '<text color="18" size="small"> [Comment:</text><text color="10" size="small">'. ($nextPageToken+1) .'</text><text color="18" size="small">]</text>');
					ControlFactory::add_smart_label($defs,"", '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/like.png</icon><text color="18" size="small"> Likes:</text><text color="10" size="small">'. $jsd->likeCount .'</text>');
					ControlFactory::add_multiline_label($defs, '', $coments, 12);
					
					$w = 1500;
				}else
					$coments = '';
			}else
				$coments = '';
			if ($coments != ''){
				$add_params ['nextPageToken'] = $nextPageToken + 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t139', 350);
				$add_params ['nextPageToken'] = $nextPageToken - 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t140', 350);
				if (isset($jsd->authorChannelId->value)){
					$add_params ['coment_url_user'] = $jsd->authorChannelId->value;
					$add_params ['coment_name_user'] = $jsd->authorDisplayName;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'coment_user', '', '%tr%t141', 350);
				}	
			}else{
				$nextPageToken = false;
				$w = 0; $pages = '%tr%t142';
				ControlFactory::add_close_dialog_button($defs,'OK', 250);
			}
			return  ActionFactory::show_dialog($pages ,$defs,true,$w,$attrs);
		}
		
		if ($user_input->control_id === 'coment_user'){
			
			return ActionFactory::open_folder(VodChannelScreen::get_media_url_str('channel', $user_input->coment_url_user, $user_input->coment_name_user),$user_input->coment_name_user);
		}
		
		if ($user_input->control_id == 'search'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_search', '',
			$media_url->name, 0, 0, $use_osk, 1, 1300,0,1);
			if ($use_osk == 1)
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t54', $defs, true, 0,$attrs);
		}
		
		if ($user_input->control_id == 'do_new_search'){
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_search');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		
		if ($user_input->control_id == 'do_search'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			HD::save_item('search_item', $user_input->do_new_search);
			$search_items = HD::get_items('search_items');
			$k = array_search($user_input->do_new_search, $search_items);
			if ($k !== false)
				unset ($search_items [$k]);
			array_unshift($search_items, $user_input->do_new_search); 
			HD::save_items('search_items', $search_items);
			$action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('search', $user_input->do_new_search), "%ext%<key_local>o__1<p>".$user_input->do_new_search."</p></key_local>");
			return ActionFactory::invalidate_folders(array('search_screen'),$action);
		}
		
		if ($user_input->control_id == 'add_favorite'){
            if (!isset($user_input->selected_media_url))
                return null;
			$this->vod->ensure_favorites_loaded($plugin_cookies);
			$is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
			$ufav_itms = HD::get_items('ufav_itms');
			if (!empty($ufav_itms)){
				if ($is_favorite)
					$caption = '%tr%t68';
				else
					$caption = '%tr%t69';

				$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav',$params);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				foreach ($ufav_itms as $k => $v){
					$flipped = array_flip(HD::get_items($k));
					if (isset($flipped[$user_input->selected_media_url]))
						$caption = "%ext%<key_local>i1__1<p>$v</p></key_local>";
					else
						$caption = "%ext%<key_local>i__1<p>$v</p></key_local>";
					$params['ufav_itms_name'] = $k;
					$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav_itm',$params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				}
				return ActionFactory::show_dialog('%tr%t55', $defs, true, 0,$attrs);
			}else{
				if ($is_favorite){
					$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t70');
				}else{
					$this->vod->add_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t71');
				}
			}
			
        }
		if ($user_input->control_id == 'add_fav_itm'){
            if (!isset($user_input->selected_media_url))
                return null;
			$fav_movies = HD::get_items($user_input->ufav_itms_name);
			$flipped = array_flip($fav_movies);
			if (isset($flipped[$user_input->selected_media_url])){
				unset ($flipped[$user_input->selected_media_url]);
				$fav_movies = array_flip($flipped);
				$fav_movies = array_values($fav_movies);
				HD::save_items($user_input->ufav_itms_name, $fav_movies);
				return ActionFactory::show_title_dialog_gl('%tr%t70');
			}
			HD::save_items($user_input->ufav_itms_name, $fav_movies);
			return ActionFactory::show_title_dialog_gl('%tr%t71');
        }
		if ($user_input->control_id == 'add_fav'){
            if (!isset($user_input->selected_media_url))
                return null;
			$this->vod->ensure_favorites_loaded($plugin_cookies);
            $is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
            if ($is_favorite){
				$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
                return ActionFactory::show_title_dialog_gl('%tr%t70');
			}
        }
        return null;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
